(define-module (ordo interceptor command)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-145)
  #:use-module (ordo interceptor)
  #:use-module (ordo connection)
  #:use-module (ordo util flatten)
  #:export (command))

(define* (command name prog-and-args #:key register)
  (assume (string? name) "interceptor name should be a string" name)
  (assume (list? prog-and-args) "prog-and-args should be a list" prog-and-args)
  (assume (or (not register) (symbol? register)) "register should be a symbol" register)
  (interceptor
   name
   #:enter (lambda (ctx)
             (let ((prog-and-args (map (lambda (v) (expand-vars ctx v)) (flatten prog-and-args))))
               (pk prog-and-args)
               (call-with-values
                   (lambda () (apply run (context-connection ctx) prog-and-args))
                 (lambda result
                   (when register
                     (var-set! ctx register result))))))))
