(define-module (ordo interceptor download)
  #:use-module (ice-9 filesystem)
  #:use-module (srfi srfi-71)
  #:use-module (srfi srfi-145)
  #:use-module (ordo interceptor)
  #:use-module (ordo connection)
  #:export (download))

(define* (download name #:key url target-dir register)
  (assume (string? name) "interceptor name should be a string" name)
  (assume (or (string? url) (delayed-var-ref? url)) "url is required and should be a string" url)
  (assume (or (not register) (symbol? register)) "register should be a symbol" register)
  (interceptor
   name
   #:enter (lambda (ctx)
             (let* ((url target-dir (expand-vars ctx url target-dir))
                    (file-name (file-name-join* target-dir (file-basename url))))
               (run (context-connection ctx) "wget" "-O" file-name url #:check? #t)
               (when register
                 (var-set! ctx register file-name))))
   #:leave (lambda (ctx) (when register (var-delete! ctx register)))
   #:error (lambda (ctx) (when register (var-delete! ctx register)))))
