(define-module (ordo interceptor require-commands)
  #:use-module (ice-9 exceptions)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-71)
  #:use-module (srfi srfi-145)
  #:use-module (ordo interceptor)
  #:use-module (ordo connection)
  #:export (require-commands))

(define-exception-type &missing-command-error &external-error
  make-missing-command-error
  missing-command-error?
  (command-name missing-command-error-command-name))

(define (require-commands . commands)
  (assume (every string? commands) "commands should be strings" commands)
  (interceptor
   (string-append "require-commands " (string-join commands ","))
   #:enter (lambda (ctx)
             (for-each (lambda (cmd)
                         (let ((out rc (run (context-connection ctx) "which" cmd)))
                           (unless (zero? rc)
                             (if (string-contains (car out) (format #f "which: no ~a in" cmd))
                                 (raise-exception (make-missing-command-error cmd))
                                 (raise-exception (make-exception
                                                   (make-external-error)
                                                   (make-exception-with-message (string-append "error running which: " (car out)))))))))
                       commands))))
