(define-module (ordo interceptor unzip)
  #:use-module (srfi srfi-71)
  #:use-module (srfi srfi-145)
  #:use-module (ordo interceptor)
  #:use-module (ordo connection)
  #:export (unzip))

(define* (unzip name #:key file-name target-dir)
  (assume (string? name) "interceptor name is required and should be a string" name)
  (assume (or (string? file-name) (delayed-var-ref? file-name)) "file-name is required and should be a string" file-name)
  (assume (or (string? target-dir) (delayed-var-ref? target-dir)) "target-dir is required and should be a string" target-dir)
  (interceptor
   name
   #:enter (lambda (ctx)
             (let ((file-name target-dir (expand-vars ctx file-name target-dir)))
               (run (context-connection ctx) "unzip" file-name "-d" target-dir #:check? #t)))))
